org.apache.uima.util.impl

## Class Logger_common_impl

- java.lang.Object
- - org.apache.uima.util.impl.Logger_common_impl

- All Implemented Interfaces:
    org.slf4j.Logger
  Direct Known Subclasses:
    JSR47Logger_impl, Log4jLogger_impl, Logger_impl, Slf4jLogger_impl

      public abstract class Logger_common_impl
      extends Object
      implements Logger

  UIMA Logging interface common implementation Specific loggers extend this class

  Logging "location" information:

  - This is the Classname / Methodname / and maybe line number where the logging statement is
  - is passed in on the logrb calls, but is not needed by modern loggers.
  - In V3, passed in value is ignored; loggers get what they need as configured.
  - In Java 9 this will be efficient

  Limiting or throttling loggers: This is normally done using logger configuration. For cases where UIMA is running as an embedded library, sometimes Annotators log excessivly, and users do not have access to the logging configuration. But they do have access to APIs which create the UIMA pipelines.

  V3 supports an additional param, AnalysisEngine.PARAM_THROTTLE_EXCESSIVE_ANNOTATOR_LOGGING which if set, specifies a limit of the number of log messages issued by Annotator code.

  This requires:

  - marking loggers if they are Annotator loggers (e.g., their associated "class" used in setting the name of the logger, is assignable to AnalysisComponent_ImplBase, which includes: Annotators, CasMultipliers, and UimacppAnalysisComponents.
  - When setting up a logger in the UimaContext logger code (via setLogger), checking if the logger is an Annotator logger, and if so, setting the limit on it from the parameter associated with the UIMA context.

  The loggers with a limit are cloned for the particular pipeline (represented by the root UIMA context), so that setting the limit only affects one pipeline.

  The common part of logging does:

  - optional throttling
  - the UIMA specific resource bundle message conversions
  - the conversion of variants of log methods to standard ones

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static String[]` | `EMPTY_STACK_TRACE_INFO`
    `protected static String` | `EXCEPTION_MESSAGE`
    `protected String` | `fqcn`
    `protected String` | `fqcnCmn`
    `protected int` | `limit_common`

    - ### Fields inherited from interface org.apache.uima.util.Logger

      `UIMA_MARKER_CONFIG, UIMA_MARKER_FINEST`

    - ### Fields inherited from interface org.slf4j.Logger

      `ROOT_LOGGER_NAME`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `Logger_common_impl(Class<?> component)`
    `protected` | `Logger_common_impl(Logger_common_impl lci, int limit)` Copy constructor for limited loggers

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `debug(org.slf4j.Marker arg0, String arg1)`
    `void` | `debug(org.slf4j.Marker arg0, String arg1, Object... arg2)`
    `void` | `debug(org.slf4j.Marker arg0, String arg1, Object arg2)`
    `void` | `debug(org.slf4j.Marker arg0, String arg1, Object arg2, Object arg3)`
    `void` | `debug(org.slf4j.Marker marker, String message, Supplier<?>... paramSuppliers)`
    `void` | `debug(org.slf4j.Marker arg0, String arg1, Throwable arg2)`
    `void` | `debug(org.slf4j.Marker marker, Supplier<String> msgSupplier)`
    `void` | `debug(org.slf4j.Marker marker, Supplier<String> msgSupplier, Throwable throwable)`
    `void` | `debug(String arg0)` Convert standard call varieties
    `void` | `debug(String arg0, Object... arg1)`
    `void` | `debug(String arg0, Object arg1)`
    `void` | `debug(String arg0, Object arg1, Object arg2)`
    `void` | `debug(String message, Supplier<?>... paramSuppliers)`
    `void` | `debug(String arg0, Throwable arg1)`
    `void` | `debug(Supplier<String> msgSupplier)`
    `void` | `debug(Supplier<String> msgSupplier, Throwable throwable)`
    `void` | `error(org.slf4j.Marker arg0, String arg1)`
    `void` | `error(org.slf4j.Marker arg0, String arg1, Object... arg2)`
    `void` | `error(org.slf4j.Marker arg0, String arg1, Object arg2)`
    `void` | `error(org.slf4j.Marker arg0, String arg1, Object arg2, Object arg3)`
    `void` | `error(org.slf4j.Marker marker, String message, Supplier<?>... paramSuppliers)`
    `void` | `error(org.slf4j.Marker arg0, String arg1, Throwable arg2)`
    `void` | `error(org.slf4j.Marker marker, Supplier<String> msgSupplier)`
    `void` | `error(org.slf4j.Marker marker, Supplier<String> msgSupplier, Throwable throwable)`
    `void` | `error(String arg0)`
    `void` | `error(String arg0, Object... arg1)`
    `void` | `error(String arg0, Object arg1)`
    `void` | `error(String arg0, Object arg1, Object arg2)`
    `void` | `error(String message, Supplier<?>... paramSuppliers)`
    `void` | `error(String arg0, Throwable arg1)`
    `void` | `error(Supplier<String> msgSupplier)`
    `void` | `error(Supplier<String> msgSupplier, Throwable throwable)`
    `static org.slf4j.Marker` | `getMarkerForLevel(Level level)`
    `void` | `info(org.slf4j.Marker arg0, String arg1)`
    `void` | `info(org.slf4j.Marker arg0, String arg1, Object... arg2)`
    `void` | `info(org.slf4j.Marker arg0, String arg1, Object arg2)`
    `void` | `info(org.slf4j.Marker arg0, String arg1, Object arg2, Object arg3)`
    `void` | `info(org.slf4j.Marker marker, String message, Supplier<?>... paramSuppliers)`
    `void` | `info(org.slf4j.Marker arg0, String arg1, Throwable arg2)`
    `void` | `info(org.slf4j.Marker marker, Supplier<String> msgSupplier)`
    `void` | `info(org.slf4j.Marker marker, Supplier<String> msgSupplier, Throwable throwable)`
    `void` | `info(String arg0)`
    `void` | `info(String arg0, Object... arg1)`
    `void` | `info(String arg0, Object arg1)`
    `void` | `info(String arg0, Object arg1, Object arg2)`
    `void` | `info(String message, Supplier<?>... paramSuppliers)`
    `void` | `info(String arg0, Throwable arg1)`
    `void` | `info(Supplier<String> msgSupplier)`
    `void` | `info(Supplier<String> msgSupplier, Throwable throwable)`
    `boolean` | `isAnnotatorLogger()` This is true if the name of the logger corresponds to a class which implements AnalysisComponent_ImplBase, which includes basic Annotators, plus Cas Multipliers and CPP components.
    `protected boolean` | `isEmpty(String v)`
    `void` | `log(Level level, String aMessage)` Logs a message.
    `void` | `log(Level level, String aMessage, Object param1)` Logs a message with one parameter
    `void` | `log(Level level, String aMessage, Object[] params)` Logs a message with an arbitrary number of parameters
    `void` | `log(Level level, String aMessage, Throwable thrown)` Logs a message and a throwable object
    `abstract void` | `log(org.slf4j.Marker m, String aFqcn, Level level, String message, Object[] args, Throwable throwable)` The main log call implemented by subclasses
    `abstract void` | `log(org.slf4j.Marker m, String aFqcn, Level level, String message, Throwable throwable)` The version of the main log call implemented by subclasses that skips the substitution because it already was done by rb()
    `void` | `log(String aMessage)` Deprecated. use new function with log level
    `void` | `log(String aFqcn, Level level, String message, Throwable thrown)` Convert a standard UIMA call for wrapped loggers
    `void` | `log(String aResourceBundleName, String aMessageKey, Object[] aArguments)` Deprecated. use new function with log level
    `abstract void` | `log2(org.slf4j.Marker m, String aFqcn, Level level, String message, Object[] args, Throwable throwable)` The version of the main log call implemented by subclasses that uses {}, not {n} as the substitutable syntax.
    `void` | `logException(Exception aException)` Deprecated. use new function with log level
    `void` | `logrb(Level level, String sourceClass, String sourceMethod, String bundleName, String msgKey)` Logs a message with a message key.
    `void` | `logrb(Level level, String sourceClass, String sourceMethod, String bundleName, String msgKey, Object param1)` Logs a message with a message key and one parameter.
    `void` | `logrb(Level level, String sourceClass, String sourceMethod, String bundleName, String msgKey, Object[] params)` Logs a message with a message key and an arbitrary number of parameters.
    `void` | `logrb(Level level, String sourceClass, String sourceMethod, String bundleName, String msgKey, Throwable thrown)` Logs a message with a message key and a throwable object.
    `String` | `rb(String bundleName, String msgKey, Object... parameters)` Get an internationalized message from a resource bundle by key name, substituting the parameters.
    `void` | `setAnnotatorLogger(boolean v)`
    `void` | `setOutputStream(OutputStream out)` Deprecated. use external configuration possibility
    `void` | `setOutputStream(PrintStream out)` Deprecated. use external configuration possibility
    `void` | `setResourceManager(ResourceManager resourceManager)` Deprecated.
    `void` | `trace(org.slf4j.Marker arg0, String arg1)`
    `void` | `trace(org.slf4j.Marker arg0, String arg1, Object... arg2)`
    `void` | `trace(org.slf4j.Marker arg0, String arg1, Object arg2)`
    `void` | `trace(org.slf4j.Marker arg0, String arg1, Object arg2, Object arg3)`
    `void` | `trace(org.slf4j.Marker marker, String message, Supplier<?>... paramSuppliers)`
    `void` | `trace(org.slf4j.Marker arg0, String arg1, Throwable arg2)`
    `void` | `trace(org.slf4j.Marker marker, Supplier<String> msgSupplier)`
    `void` | `trace(org.slf4j.Marker marker, Supplier<String> msgSupplier, Throwable throwable)`
    `void` | `trace(String arg0)`
    `void` | `trace(String arg0, Object... arg1)`
    `void` | `trace(String arg0, Object arg1)`
    `void` | `trace(String arg0, Object arg1, Object arg2)`
    `void` | `trace(String message, Supplier<?>... paramSuppliers)`
    `void` | `trace(String arg0, Throwable arg1)`
    `void` | `trace(Supplier<String> msgSupplier)`
    `void` | `trace(Supplier<String> msgSupplier, Throwable throwable)`
    `void` | `warn(org.slf4j.Marker arg0, String arg1)`
    `void` | `warn(org.slf4j.Marker arg0, String arg1, Object... arg2)`
    `void` | `warn(org.slf4j.Marker arg0, String arg1, Object arg2)`
    `void` | `warn(org.slf4j.Marker arg0, String arg1, Object arg2, Object arg3)`
    `void` | `warn(org.slf4j.Marker marker, String message, Supplier<?>... paramSuppliers)`
    `void` | `warn(org.slf4j.Marker arg0, String arg1, Throwable arg2)`
    `void` | `warn(org.slf4j.Marker marker, Supplier<String> msgSupplier)`
    `void` | `warn(org.slf4j.Marker marker, Supplier<String> msgSupplier, Throwable throwable)`
    `void` | `warn(String arg0)`
    `void` | `warn(String arg0, Object... arg1)`
    `void` | `warn(String arg0, Object arg1)`
    `void` | `warn(String arg0, Object arg1, Object arg2)`
    `void` | `warn(String message, Supplier<?>... paramSuppliers)`
    `void` | `warn(String arg0, Throwable arg1)`
    `void` | `warn(Supplier<String> msgSupplier)`
    `void` | `warn(Supplier<String> msgSupplier, Throwable throwable)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.uima.util.Logger

      `getLimitedLogger, isLoggable, isLoggable, rb_ue, setLevel`

    - ### Methods inherited from interface org.slf4j.Logger

      `getName, isDebugEnabled, isDebugEnabled, isErrorEnabled, isErrorEnabled, isInfoEnabled, isInfoEnabled, isTraceEnabled, isTraceEnabled, isWarnEnabled, isWarnEnabled`

- - ### Field Detail

    - #### EXCEPTION_MESSAGE

          protected static final String EXCEPTION_MESSAGE

      See Also:
        Constant Field Values

    - #### EMPTY_STACK_TRACE_INFO

          protected static final String[] EMPTY_STACK_TRACE_INFO

    - #### fqcn

          protected final String fqcn

    - #### fqcnCmn

          protected final String fqcnCmn

    - #### limit_common

          protected final int limit_common

  - ### Constructor Detail

    - #### Logger_common_impl

          protected Logger_common_impl(Class<?> component)

    - #### Logger_common_impl

          protected Logger_common_impl(Logger_common_impl lci,
                                       int limit)

      Copy constructor for limited loggers
      Parameters:
        `lci` - the original logger to copy
        `limit` - the limit

  - ### Method Detail

    - #### log

          public abstract void log(org.slf4j.Marker m,
                                   String aFqcn,
                                   Level level,
                                   String message,
                                   Object[] args,
                                   Throwable throwable)

      The main log call implemented by subclasses
      Parameters:
        `m` - the marker
        `aFqcn` - the fully qualified class name of the top-most logging class used to filter the stack trace to get the caller class / method info
        `level` - the UIMA level
        `message` - -
        `args` - - arguments to be substituted into the message
        `throwable` - - can be null

    - #### log2

          public abstract void log2(org.slf4j.Marker m,
                                    String aFqcn,
                                    Level level,
                                    String message,
                                    Object[] args,
                                    Throwable throwable)

      The version of the main log call implemented by subclasses that uses {}, not {n} as the substitutable syntax. This syntax is used by log4j, slf4j, and others. But not used by uimaj logger basic syntax, or Java Util Logger. This version is called by all new logging statments that don't need to be backwards compatible. e.g. logger.info, logger.error, logger.warn, etc.
      Parameters:
        `m` - the marker
        `aFqcn` - the fully qualified class name of the top-most logging class used to filter the stack trace to get the caller class / method info
        `level` - the UIMA level
        `message` - -
        `args` - - arguments to be substituted into the message
        `throwable` - - can be null

    - #### log

          public abstract void log(org.slf4j.Marker m,
                                   String aFqcn,
                                   Level level,
                                   String message,
                                   Throwable throwable)

      The version of the main log call implemented by subclasses that skips the substitution because it already was done by rb()
      Parameters:
        `m` - the marker
        `aFqcn` - the fully qualified class name of the top-most logging class used to filter the stack trace to get the caller class / method info
        `level` - the UIMA level
        `message` - -
        `throwable` - - can be null

    - #### getMarkerForLevel

          public static org.slf4j.Marker getMarkerForLevel(Level level)

      Parameters:
        `level` - the Uima Level
      Returns:
        the Marker to use

    - #### log

          public void log(String aFqcn,
                          Level level,
                          String message,
                          Throwable thrown)

      Convert a standard UIMA call for wrapped loggers
      Parameters:
        `aFqcn` - - fully qualified class name of highest level of logging impl. The class / method above this in the stack trace is used for identifying where the logging call originated from.
        `level` - the uima Level
        `message` - the message
        `thrown` - may be null

    - #### setOutputStream

          @Deprecated
          public void setOutputStream(OutputStream out)

      Deprecated. use external configuration possibility
      Description copied from interface: `Logger`
      Sets the output stream to which log messages will go. Setting the output stream to `null` will disable the logger.
      Parameters:
        `out` - `OutputStream` to which log messages will be printed
      See Also:
        `Logger.setOutputStream(java.io.OutputStream)`

    - #### setOutputStream

          @Deprecated
          public void setOutputStream(PrintStream out)

      Deprecated. use external configuration possibility
      Description copied from interface: `Logger`
      Sets the output stream to which log messages will go. Setting the output stream to `null` will disable the logger.
      Parameters:
        `out` - `PrintStream` to which log messages will be printed
      See Also:
        `Logger.setOutputStream(java.io.PrintStream)`

    - #### log

          @Deprecated
          public void log(String aMessage)

      Deprecated. use new function with log level
      Logs a message with level INFO.
      Parameters:
        `aMessage` - the message to be logged

    - #### log

          @Deprecated
          public void log(String aResourceBundleName,
                                      String aMessageKey,
                                      Object[] aArguments)

      Deprecated. use new function with log level
      Logs a message with a message key and the level INFO
      Parameters:
        `aResourceBundleName` - base name of resource bundle
        `aMessageKey` - key of message to localize with message level INFO
        `aArguments` - arguments to message (may be null if none)
      See Also:
        `Logger.log(java.lang.String, java.lang.String, java.lang.Object[])`

    - #### logException

          @Deprecated
          public void logException(Exception aException)

      Deprecated. use new function with log level
      Logs an exception with level INFO
      Parameters:
        `aException` - the exception to be logged

    - #### log

          public void log(Level level,
                          String aMessage)

      Description copied from interface: `Logger`
      Logs a message.
      Parameters:
        `level` - message level
        `aMessage` - the message to be logged

    - #### log

          public void log(Level level,
                          String aMessage,
                          Object param1)

      Description copied from interface: `Logger`
      Logs a message with one parameter
      Parameters:
        `level` - message level
        `aMessage` - the message to be logged
        `param1` - message parameter

    - #### log

          public void log(Level level,
                          String aMessage,
                          Object[] params)

      Description copied from interface: `Logger`
      Logs a message with an arbitrary number of parameters
      Parameters:
        `level` - message level
        `aMessage` - the message to be logged
        `params` - message parameter array

    - #### log

          public void log(Level level,
                          String aMessage,
                          Throwable thrown)

      Description copied from interface: `Logger`
      Logs a message and a throwable object
      Parameters:
        `level` - message level
        `aMessage` - the message to be logged
        `thrown` - throwable object

    - #### logrb

          public void logrb(Level level,
                            String sourceClass,
                            String sourceMethod,
                            String bundleName,
                            String msgKey,
                            Object param1)

      Description copied from interface: `Logger`
      Logs a message with a message key and one parameter. The real message is extracted from a resource bundle.
      Parameters:
        `level` - message level
        `sourceClass` - source class name
        `sourceMethod` - source method name
        `bundleName` - resource bundle
        `msgKey` - message key
        `param1` - message parameter

    - #### logrb

          public void logrb(Level level,
                            String sourceClass,
                            String sourceMethod,
                            String bundleName,
                            String msgKey,
                            Object[] params)

      Description copied from interface: `Logger`
      Logs a message with a message key and an arbitrary number of parameters. The real message is extracted from a resource bundle.
      Parameters:
        `level` - message level
        `sourceClass` - source class name
        `sourceMethod` - source method name
        `bundleName` - resource bundle
        `msgKey` - message key
        `params` - message parameter array with an arbitrary number of parameters

    - #### logrb

          public void logrb(Level level,
                            String sourceClass,
                            String sourceMethod,
                            String bundleName,
                            String msgKey,
                            Throwable thrown)

      Description copied from interface: `Logger`
      Logs a message with a message key and a throwable object. The real message is extracted from a resource bundle.
      Parameters:
        `level` - message level
        `sourceClass` - source class name
        `sourceMethod` - source method name
        `bundleName` - resource bundle
        `msgKey` - message key
        `thrown` - throwable object

    - #### logrb

          public void logrb(Level level,
                            String sourceClass,
                            String sourceMethod,
                            String bundleName,
                            String msgKey)

      Description copied from interface: `Logger`
      Logs a message with a message key. The real message is extracted from a resource bundle.
      Parameters:
        `level` - message level
        `sourceClass` - source class name
        `sourceMethod` - source method name
        `bundleName` - resource bundle
        `msgKey` - message key

    - #### setResourceManager

          @Deprecated
          public void setResourceManager(ResourceManager resourceManager)

      Deprecated.
      Description copied from interface: `Logger`
      Sets the ResourceManager to use for message localization. This method is intended for use by the framework, not by user code.
      Parameters:
        `resourceManager` - A resource manager instance whose extension ClassLoader (if any) will be used for message localization by this logger.

    - #### rb

          public String rb(String bundleName,
                           String msgKey,
                           Object... parameters)

      Description copied from interface: `Logger`
      Get an internationalized message from a resource bundle by key name, substituting the parameters. This should be called via a Supplier to avoid computing this until needed
      Parameters:
        `bundleName` - -
        `msgKey` - -
        `parameters` - -
      Returns:
        the internationalized message

    - #### isEmpty

          protected boolean isEmpty(String v)

    - #### isAnnotatorLogger

          public boolean isAnnotatorLogger()

      Description copied from interface: `Logger`
      This is true if the name of the logger corresponds to a class which implements AnalysisComponent_ImplBase, which includes basic Annotators, plus Cas Multipliers and CPP components.
      Returns:
        true if this logger is an Annotator logger.

    - #### setAnnotatorLogger

          public void setAnnotatorLogger(boolean v)

    - #### debug

          public void debug(String arg0)

      Convert standard call varieties
      Specified by:
        `debug` in interface `org.slf4j.Logger`

    - #### debug

          public void debug(String arg0,
                            Object arg1)

      Specified by:
        `debug` in interface `org.slf4j.Logger`

    - #### debug

          public void debug(String arg0,
                            Object... arg1)

      Specified by:
        `debug` in interface `org.slf4j.Logger`

    - #### debug

          public void debug(String arg0,
                            Throwable arg1)

      Specified by:
        `debug` in interface `org.slf4j.Logger`

    - #### debug

          public void debug(org.slf4j.Marker arg0,
                            String arg1)

      Specified by:
        `debug` in interface `org.slf4j.Logger`

    - #### debug

          public void debug(String arg0,
                            Object arg1,
                            Object arg2)

      Specified by:
        `debug` in interface `org.slf4j.Logger`

    - #### debug

          public void debug(org.slf4j.Marker arg0,
                            String arg1,
                            Object arg2)

      Specified by:
        `debug` in interface `org.slf4j.Logger`

    - #### debug

          public void debug(org.slf4j.Marker arg0,
                            String arg1,
                            Object... arg2)

      Specified by:
        `debug` in interface `org.slf4j.Logger`

    - #### debug

          public void debug(org.slf4j.Marker arg0,
                            String arg1,
                            Throwable arg2)

      Specified by:
        `debug` in interface `org.slf4j.Logger`

    - #### debug

          public void debug(org.slf4j.Marker arg0,
                            String arg1,
                            Object arg2,
                            Object arg3)

      Specified by:
        `debug` in interface `org.slf4j.Logger`

    - #### debug

          public void debug(Supplier<String> msgSupplier)

      Parameters:
        `msgSupplier` - A function, which when called, produces the desired log message

    - #### debug

          public void debug(Supplier<String> msgSupplier,
                            Throwable throwable)

      Parameters:
        `msgSupplier` - A function, which when called, produces the desired log message
        `throwable` - the exception to log

    - #### debug

          public void debug(org.slf4j.Marker marker,
                            String message,
                            Supplier<?>... paramSuppliers)

      Parameters:
        `marker` - the marker data specific to this log statement
        `message` - the message to log
        `paramSuppliers` - An array of functions, which when called, produce the desired log message parameters.

    - #### debug

          public void debug(String message,
                            Supplier<?>... paramSuppliers)

      Parameters:
        `message` - the message to log
        `paramSuppliers` - An array of functions, which when called, produce the desired log message parameters.

    - #### debug

          public void debug(org.slf4j.Marker marker,
                            Supplier<String> msgSupplier)

      Parameters:
        `marker` - the marker data specific to this log statement
        `msgSupplier` - A function, which when called, produces the desired log message

    - #### debug

          public void debug(org.slf4j.Marker marker,
                            Supplier<String> msgSupplier,
                            Throwable throwable)

      Parameters:
        `marker` - the marker data specific to this log statement
        `msgSupplier` - A function, which when called, produces the desired log message
        `throwable` - the exception to log

    - #### error

          public void error(String arg0)

      Specified by:
        `error` in interface `org.slf4j.Logger`

    - #### error

          public void error(String arg0,
                            Object arg1)

      Specified by:
        `error` in interface `org.slf4j.Logger`

    - #### error

          public void error(String arg0,
                            Object... arg1)

      Specified by:
        `error` in interface `org.slf4j.Logger`

    - #### error

          public void error(String arg0,
                            Throwable arg1)

      Specified by:
        `error` in interface `org.slf4j.Logger`

    - #### error

          public void error(org.slf4j.Marker arg0,
                            String arg1)

      Specified by:
        `error` in interface `org.slf4j.Logger`

    - #### error

          public void error(String arg0,
                            Object arg1,
                            Object arg2)

      Specified by:
        `error` in interface `org.slf4j.Logger`

    - #### error

          public void error(org.slf4j.Marker arg0,
                            String arg1,
                            Object arg2)

      Specified by:
        `error` in interface `org.slf4j.Logger`

    - #### error

          public void error(org.slf4j.Marker arg0,
                            String arg1,
                            Object... arg2)

      Specified by:
        `error` in interface `org.slf4j.Logger`

    - #### error

          public void error(org.slf4j.Marker arg0,
                            String arg1,
                            Throwable arg2)

      Specified by:
        `error` in interface `org.slf4j.Logger`

    - #### error

          public void error(org.slf4j.Marker arg0,
                            String arg1,
                            Object arg2,
                            Object arg3)

      Specified by:
        `error` in interface `org.slf4j.Logger`

    - #### error

          public void error(Supplier<String> msgSupplier)

      Parameters:
        `msgSupplier` - A function, which when called, produces the desired log message

    - #### error

          public void error(Supplier<String> msgSupplier,
                            Throwable throwable)

      Parameters:
        `msgSupplier` - A function, which when called, produces the desired log message
        `throwable` - the exception to log

    - #### error

          public void error(org.slf4j.Marker marker,
                            String message,
                            Supplier<?>... paramSuppliers)

      Parameters:
        `marker` - the marker data specific to this log statement
        `message` - the message to log
        `paramSuppliers` - An array of functions, which when called, produce the desired log message parameters.

    - #### error

          public void error(String message,
                            Supplier<?>... paramSuppliers)

      Parameters:
        `message` - the message to log
        `paramSuppliers` - An array of functions, which when called, produce the desired log message parameters.

    - #### error

          public void error(org.slf4j.Marker marker,
                            Supplier<String> msgSupplier)

      Parameters:
        `marker` - the marker data specific to this log statement
        `msgSupplier` - A function, which when called, produces the desired log message

    - #### error

          public void error(org.slf4j.Marker marker,
                            Supplier<String> msgSupplier,
                            Throwable throwable)

      Parameters:
        `marker` - the marker data specific to this log statement
        `msgSupplier` - A function, which when called, produces the desired log message
        `throwable` - the exception to log

    - #### info

          public void info(String arg0)

      Specified by:
        `info` in interface `org.slf4j.Logger`

    - #### info

          public void info(String arg0,
                           Object arg1)

      Specified by:
        `info` in interface `org.slf4j.Logger`

    - #### info

          public void info(String arg0,
                           Object... arg1)

      Specified by:
        `info` in interface `org.slf4j.Logger`

    - #### info

          public void info(String arg0,
                           Throwable arg1)

      Specified by:
        `info` in interface `org.slf4j.Logger`

    - #### info

          public void info(org.slf4j.Marker arg0,
                           String arg1)

      Specified by:
        `info` in interface `org.slf4j.Logger`

    - #### info

          public void info(String arg0,
                           Object arg1,
                           Object arg2)

      Specified by:
        `info` in interface `org.slf4j.Logger`

    - #### info

          public void info(org.slf4j.Marker arg0,
                           String arg1,
                           Object arg2)

      Specified by:
        `info` in interface `org.slf4j.Logger`

    - #### info

          public void info(org.slf4j.Marker arg0,
                           String arg1,
                           Object... arg2)

      Specified by:
        `info` in interface `org.slf4j.Logger`

    - #### info

          public void info(org.slf4j.Marker arg0,
                           String arg1,
                           Throwable arg2)

      Specified by:
        `info` in interface `org.slf4j.Logger`

    - #### info

          public void info(org.slf4j.Marker arg0,
                           String arg1,
                           Object arg2,
                           Object arg3)

      Specified by:
        `info` in interface `org.slf4j.Logger`

    - #### info

          public void info(Supplier<String> msgSupplier)

      Parameters:
        `msgSupplier` - A function, which when called, produces the desired log message

    - #### info

          public void info(Supplier<String> msgSupplier,
                           Throwable throwable)

      Parameters:
        `msgSupplier` - A function, which when called, produces the desired log message
        `throwable` - the exception to log

    - #### info

          public void info(org.slf4j.Marker marker,
                           String message,
                           Supplier<?>... paramSuppliers)

      Parameters:
        `marker` - the marker data specific to this log statement
        `message` - the message to log
        `paramSuppliers` - An array of functions, which when called, produce the desired log message parameters.

    - #### info

          public void info(String message,
                           Supplier<?>... paramSuppliers)

      Parameters:
        `message` - the message to log
        `paramSuppliers` - An array of functions, which when called, produce the desired log message parameters.

    - #### info

          public void info(org.slf4j.Marker marker,
                           Supplier<String> msgSupplier)

      Parameters:
        `marker` - the marker data specific to this log statement
        `msgSupplier` - A function, which when called, produces the desired log message

    - #### info

          public void info(org.slf4j.Marker marker,
                           Supplier<String> msgSupplier,
                           Throwable throwable)

      Parameters:
        `marker` - the marker data specific to this log statement
        `msgSupplier` - A function, which when called, produces the desired log message
        `throwable` - the exception to log

    - #### trace

          public void trace(String arg0)

      Specified by:
        `trace` in interface `org.slf4j.Logger`

    - #### trace

          public void trace(String arg0,
                            Object arg1)

      Specified by:
        `trace` in interface `org.slf4j.Logger`

    - #### trace

          public void trace(String arg0,
                            Object... arg1)

      Specified by:
        `trace` in interface `org.slf4j.Logger`

    - #### trace

          public void trace(String arg0,
                            Throwable arg1)

      Specified by:
        `trace` in interface `org.slf4j.Logger`

    - #### trace

          public void trace(org.slf4j.Marker arg0,
                            String arg1)

      Specified by:
        `trace` in interface `org.slf4j.Logger`

    - #### trace

          public void trace(String arg0,
                            Object arg1,
                            Object arg2)

      Specified by:
        `trace` in interface `org.slf4j.Logger`

    - #### trace

          public void trace(org.slf4j.Marker arg0,
                            String arg1,
                            Object arg2)

      Specified by:
        `trace` in interface `org.slf4j.Logger`

    - #### trace

          public void trace(org.slf4j.Marker arg0,
                            String arg1,
                            Object... arg2)

      Specified by:
        `trace` in interface `org.slf4j.Logger`

    - #### trace

          public void trace(org.slf4j.Marker arg0,
                            String arg1,
                            Throwable arg2)

      Specified by:
        `trace` in interface `org.slf4j.Logger`

    - #### trace

          public void trace(org.slf4j.Marker arg0,
                            String arg1,
                            Object arg2,
                            Object arg3)

      Specified by:
        `trace` in interface `org.slf4j.Logger`

    - #### trace

          public void trace(Supplier<String> msgSupplier)

      Parameters:
        `msgSupplier` - A function, which when called, produces the desired log message

    - #### trace

          public void trace(Supplier<String> msgSupplier,
                            Throwable throwable)

      Parameters:
        `msgSupplier` - A function, which when called, produces the desired log message
        `throwable` - the exception to log

    - #### trace

          public void trace(org.slf4j.Marker marker,
                            String message,
                            Supplier<?>... paramSuppliers)

      Parameters:
        `marker` - the marker data specific to this log statement
        `message` - the message to log
        `paramSuppliers` - An array of functions, which when called, produce the desired log message parameters.

    - #### trace

          public void trace(String message,
                            Supplier<?>... paramSuppliers)

      Parameters:
        `message` - the message to log
        `paramSuppliers` - An array of functions, which when called, produce the desired log message parameters.

    - #### trace

          public void trace(org.slf4j.Marker marker,
                            Supplier<String> msgSupplier)

      Parameters:
        `marker` - the marker data specific to this log statement
        `msgSupplier` - A function, which when called, produces the desired log message

    - #### trace

          public void trace(org.slf4j.Marker marker,
                            Supplier<String> msgSupplier,
                            Throwable throwable)

      Parameters:
        `marker` - the marker data specific to this log statement
        `msgSupplier` - A function, which when called, produces the desired log message
        `throwable` - the exception to log

    - #### warn

          public void warn(String arg0)

      Specified by:
        `warn` in interface `org.slf4j.Logger`

    - #### warn

          public void warn(String arg0,
                           Object arg1)

      Specified by:
        `warn` in interface `org.slf4j.Logger`

    - #### warn

          public void warn(String arg0,
                           Object... arg1)

      Specified by:
        `warn` in interface `org.slf4j.Logger`

    - #### warn

          public void warn(String arg0,
                           Throwable arg1)

      Specified by:
        `warn` in interface `org.slf4j.Logger`

    - #### warn

          public void warn(org.slf4j.Marker arg0,
                           String arg1)

      Specified by:
        `warn` in interface `org.slf4j.Logger`

    - #### warn

          public void warn(String arg0,
                           Object arg1,
                           Object arg2)

      Specified by:
        `warn` in interface `org.slf4j.Logger`

    - #### warn

          public void warn(org.slf4j.Marker arg0,
                           String arg1,
                           Object arg2)

      Specified by:
        `warn` in interface `org.slf4j.Logger`

    - #### warn

          public void warn(org.slf4j.Marker arg0,
                           String arg1,
                           Object... arg2)

      Specified by:
        `warn` in interface `org.slf4j.Logger`

    - #### warn

          public void warn(org.slf4j.Marker arg0,
                           String arg1,
                           Throwable arg2)

      Specified by:
        `warn` in interface `org.slf4j.Logger`

    - #### warn

          public void warn(org.slf4j.Marker arg0,
                           String arg1,
                           Object arg2,
                           Object arg3)

      Specified by:
        `warn` in interface `org.slf4j.Logger`

    - #### warn

          public void warn(Supplier<String> msgSupplier)

      Parameters:
        `msgSupplier` - A function, which when called, produces the desired log message

    - #### warn

          public void warn(Supplier<String> msgSupplier,
                           Throwable throwable)

      Parameters:
        `msgSupplier` - A function, which when called, produces the desired log message
        `throwable` - the exception to log

    - #### warn

          public void warn(org.slf4j.Marker marker,
                           String message,
                           Supplier<?>... paramSuppliers)

      Parameters:
        `marker` - the marker data specific to this log statement
        `message` - the message to log
        `paramSuppliers` - An array of functions, which when called, produce the desired log message parameters.

    - #### warn

          public void warn(String message,
                           Supplier<?>... paramSuppliers)

      Parameters:
        `message` - the message to log
        `paramSuppliers` - An array of functions, which when called, produce the desired log message parameters.

    - #### warn

          public void warn(org.slf4j.Marker marker,
                           Supplier<String> msgSupplier)

      Parameters:
        `marker` - the marker data specific to this log statement
        `msgSupplier` - A function, which when called, produces the desired log message

    - #### warn

          public void warn(org.slf4j.Marker marker,
                           Supplier<String> msgSupplier,
                           Throwable throwable)

      Parameters:
        `marker` - the marker data specific to this log statement
        `msgSupplier` - A function, which when called, produces the desired log message
        `throwable` - the exception to log

Copyright © 2006–2022 The Apache Software Foundation. All rights reserved.